package vm

import (
	"context"
	"github.com/jinzhu/copier"
	"github.com/pkg/errors"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/helper/xerr"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/repository/result"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/utils"
	"gitlink.org.cn/JointCloud/pcm-openstack/openstack"
	"k8s.io/apimachinery/pkg/util/json"

	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/svc"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type ListFloatingIPsLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewListFloatingIPsLogic(ctx context.Context, svcCtx *svc.ServiceContext) *ListFloatingIPsLogic {
	return &ListFloatingIPsLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *ListFloatingIPsLogic) ListFloatingIPs(req *types.ListFloatingIPsReq) (resp *types.ListFloatingIPsResp, err error) {
	// todo: add your logic here and delete this line
	ListFloatingIPsReq := &openstack.ListFloatingIPsReq{}
	err = copier.CopyWithOption(ListFloatingIPsReq, req, copier.Option{Converters: utils.Converters})
	ListFloatingIPsResp, err := l.svcCtx.OpenstackRpc.ListFloatingIPs(l.ctx, ListFloatingIPsReq)
	if err != nil {
		return nil, errors.Wrapf(xerr.NewErrMsg("c端创建失败"), "c端创建失败 : %v ,req:%+v", err, req)
	}
	marshal, err := json.Marshal(&ListFloatingIPsResp)
	if err != nil {
		return nil, result.NewDefaultError(err.Error())
	}
	json.Unmarshal(marshal, &resp)
	err = copier.CopyWithOption(&resp, &ListFloatingIPsResp, copier.Option{Converters: utils.Converters})
	return resp, err
}
